#ifdef __USE_CMSIS
#include "LPC17xx.h"
#endif

.section .text,"ax"
.cpu cortex-m3
.thumb
.syntax unified

.global funcexo1
.global funcexo2
.global funcexo3
.global funcexo4


/*****************************************************
 * function     : exercice1
 * R0: a
 * R1: b
 * R2: c
 * R3: d
 * SP: &e
 * return value : *e = a XOR b XOR c XOR d
 *****************************************************/
.thumb_func
funcexo1:
	push {r4} // sauvegarde du registre
	ldr r4, [sp, #4]
	eor r0, r1
	eor r0, r2
	eor r0, r3
	str r0, [r4]
	pop {r4} // restitution du registre

	bx  lr

/*****************************************************
 * 32 bits (unsigned) multiplication with overflow detection
 * r0: multiplicand
 * r1: multiplier
 * return values :
 * r0 = r0 * r1, r1=1 if 32 bits overflow (0 otherwise)
 *****************************************************/
.thumb_func
mult32:
	umull r0,r1,r0,r1
	cmp   r1,#0
	it    ne
	movne r1,#1				// add carry to r1
	bx    lr

/*****************************************************
 * function     : exercice 2
 * R0: a
 * R1: b
 * R2: c
 * R3: d
 * return value : a*b+c*d or 0 if overflow
 *****************************************************/
.thumb_func
funcexo2:
	push {r4, r5, lr} // sauvegarde du registre
	bl mult32
	cmp r1, #1
	beq err_ex2
	mov r4, r0
	mov r0, r2
	mov r1, r3
	bl mult32
	cmp r1, #1
	beq err_ex2
	mov r5, r0
	adds r4, r5
	bhi err_ex2
	mov r0, r4
	pop {r4, r5, lr} // restitution du registre
	bx  lr

err_ex2:
	pop {r4, r5, lr} // restitution du registre
	mov r0, #0
	bx	lr
	
	
/*****************************************************
 * function     : exercice 3
 * R0: a
 * R1: b and c (c in high 16 bits)
 * R2: d
 * R3: e
 * return value : addition of the elements of the structure
 *****************************************************/
.thumb_func
funcexo3:
	// push {r4}
	// c in r4
	// mov r


	// bx    lr




/*****************************************************
 * function     : exercice 4
 * R0: n
 * return value : value of fibonacci sequence for n
 *****************************************************/
.thumb_func
funcexo4:
	subs r0, #1
	bne rcall
	mov r0, #1
	// add sp, #8
	bx lr

rcall:
	push {r0, lr}
	bl funcexo4
	pop {r0, lr}
	add r0, r0
	bx lr

exit:
	pop {r0, lr}
	add r0, r0
	bx lr




/*funcexo4:
	mov r1, r0
	push {r0, r1, lr}
	bl lhs_fact

lhs_fact:
	pop {r0, r1, lr}
	sub r0, #1
	cmp r0, #1
	bgt lhs_fact
	bl rhs_fact

rhs_fact:


exit_ret:
	pop {r0, r1, lr}
	mov r0, #1

	bx	lr



fact:
	push {r0, r1, lr}
	sub r0, #1
	cmp r0, #1
	bgt rcall
	sub r1, #2
	cmp r1, #1
	bgt rcall
	add sp, #12

	bx	lr


rcall:
	bl fact
	pop {r0, r1, lr}
	add r0, r1

	bx	lr*/


//.weak add_sat
.ltorg
