/****************************************************************************
 DMA constants definition
****************************************************************************/
#ifndef __DMA_H 
#define __DMA_H

#define DMA_SRC			0x2007C000
#define DMA_DST			0x20080000
#define DMA_SIZE		0x1000

#define M2M				0x00
#define M2P				0x01
#define P2M				0x02
#define P2P				0x03

#define BURST1 0x0
#define HALFWORD16_TRANSFER 0x1
#define INCREMENT 1
#define TERMINAL_INTERRUPT 0x80000000

#define DMA_CFG ((BURST1 << 12) | (BURST1 << 15) \
		| (HALFWORD16_TRANSFER << 18) | (HALFWORD16_TRANSFER << 21) | \
		TERMINAL_INTERRUPT)

void DMA_Init(uint32_t *src, uint32_t *dest, uint32_t len, uint32_t LLI);

typedef struct
{
  volatile uint32_t DMACCSrcAddr;
  volatile uint32_t DMACCDestAddr;
  volatile uint32_t DMACCLLI;
  volatile uint32_t DMACCControl;
} GPDMALLI_t;

#endif

