/*
 * dma_ssp.h
 *
 *  Created on: July 2023
 *  Author: VP
 */

#ifndef DMA_SSP_H_
#define DMA_SSP_H_

#include <stdbool.h>
#include <stdint.h>

#define SSPSR_BSY               (1 << 4)

/* Description: SSP0 initialisation
 * Parameters: data_size_select: number of bits per word
 *             scr: SSP clock divider -1 (scr=0 means divided by 1)
 */
void ssp0_init(uint8_t data_size_select, uint8_t scr);

/* Description: initialize DMA channel 0 for SSP0  */
void init_dma_ssp0();

/* Description: start a transfer of word_len 16 bits words on SSP0
 * Parameters: - words: pointer on the words to copy from memory to SSP0
 *             - word_len: number of words to copy
 *             - is_src_incr: increment source address if true
 */
void ssp_DMA_uint16_transfer(uint16_t *words, uint16_t word_len, bool is_src_incr);


#endif /* DMA_SSP_H_ */
